#ifndef A8_H
#define A8_H

#include <assert.h>

#include <string>
#include <vector>
#include <map>
#include <list>
#include <set>
#include <tuple>
#include <memory>
#include <functional>
#include <initializer_list>

#include <a8/types.h>
#include <a8/list.h>
#include <a8/xvalue.h>
#include <a8/xobject.h>
#include <a8/xparams.h>
#include <a8/timer_attacher.h>

#include <a8/strutils.h>
#include <a8/sysutils.h>
#include <a8/singleton.h>

namespace std
{
    class thread;
    class mutex;
    class condition_variable;
};

#define NEW_NET
#define A8_SAFE_DELETE(p) { if(p){delete(p);  (p)=nullptr;} }
#define A8_DEFINE_RANGE_BIT(type, begin, end) ((((type)1) << (end + 1)) - 1) & (~((((type)1) << (begin + 0)) - 1))

#define A8_ABORT() do{printf("abort file:%s line:%d func:%s\n", __FILE__, __LINE__, __func__);fflush(stdout);fflush(stderr);abort();}while(0);

const float A8_PI = 3.1415926f;

#endif
