#include <stdio.h>

#include <a8/a8.h>
#include <a8/inifile.h>

namespace a8
{
    IniFile::IniFile(const std::string filename): filename_(filename)
    {
    }

    bool IniFile::Load()
    {
        sections_.clear();

        std::string tmpstr, sectionname;
        a8::StringList tmplist;
        if(tmplist.LoadFromFile(filename_.c_str())){
            for(int i = 0; i < tmplist.Count(); i++){
                a8::GetValidStr(tmplist.String(i), tmpstr);
                if(tmpstr.size() >= 3 &&
                   tmpstr[0] == '[' &&
                   tmpstr[tmpstr.size() - 1] == ']'){
                    //read section name
                    sectionname = tmpstr.substr(1, tmpstr.length() - 2);
                    sections_[sectionname] = std::map<std::string, std::string>();
                }else if(sectionname.size() > 0){
                    //read keyvalue
                    unsigned int pos = tmpstr.find('=');
                    if(pos != std::string::npos){
                        auto itr = sections_.find(sectionname);
                        if(itr != sections_.end()){
                            std::string key = std::string(tmpstr, 0, pos);
                            std::string val = std::string(tmpstr, pos + 1, tmpstr.length() - pos - 1);
                            itr->second[key] = val;
                        }
                    }
                }
            }//end for
            return true;
        } else {
            return false;
        }
    }

}
