#ifndef A8_LUAENGINE_H
#define A8_LUAENGINE_H

struct lua_State;
namespace a8
{

    class LuaEngine
    {
    public:

        LuaEngine();
        ~LuaEngine();

        void Init(const std::string& lua_path);
        void UnInit();
        std::string GetErrorMsg() { return last_error_msg_; };
        lua_State* GetLuaState() { return lua_state_; };
        bool LoadModule(const std::string& module_name);
        bool LoadString(const std::string& str);
        std::tuple<bool, a8::XValue> CallGlobalFunc(const char* func_name,
                                                    std::initializer_list<a8::XValue> args);
        std::tuple<bool, a8::XValue> CallModuleFunc(const char* module_name,
                                                    const char* func_name,
                                                    std::initializer_list<a8::XValue> args);

    private:

        bool CallLuaFunc(const char* module_name,
                         const char* func_name,
                         std::initializer_list<a8::XValue>& args,
                         a8::XValue& result);
        void OnScriptError(const std::string& errmsg);

    private:
        lua_State* lua_state_ = nullptr;
        std::string lua_path_;
        std::string last_error_msg_;

    };

}

#endif
