#ifndef A8_TIMERFD_H
#define A8_TIMERFD_H

#include <a8/epolleventhandler.h>

namespace a8
{
    class TimerFD : public EpollEventHandler
    {
    public:
        std::function<void (void*, unsigned long long)> OnTimer;

        TimerFD();
        virtual ~TimerFD();

        void Init(void* context);
        void UnInit();
        void Start(long long ms);
        void Stop();
        virtual void SetEpollFd(int epoll_fd) override;
        virtual void DoRecv() override;
        virtual void DoSend() override;
        virtual void DoError() override;

    private:
        int epoll_fd_ = a8::INVALID_FD;
        void* context_ = nullptr;
        int fd_ = a8::INVALID_FD;
    };
}

#endif
